Package org.jfree.layouting.normalizer.generator

## Interface ContentGenerator

- All Superinterfaces:
    `StatefullComponent`
  All Known Implementing Classes:
    `DefaultContentGenerator`, `EmptyContentGenerator`, `PrintContentGenerator`

      public interface ContentGenerator
      extends StatefullComponent

  The content generator is the third stage content processor. This part is responsible to process the generated display model and to prepare it for rendering it to the output medium.

  In the simplest case, the content generator will be able to pass the display model without any changes. In the more complicated cases, the display model needs to be flattened (as text processors cannot contain paragraphs inside other paragraphs, for instance) before it can be rendered.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addContent​(LayoutContext node, ContentToken contentToken)` |
    `void` | `addPassThroughContent​(LayoutContext node, ContentToken token)` |
    `void` | `finishedBlock​()` |
    `void` | `finishedDocument​()` | Receives notification, that a new flow has started.
    `void` | `finishedFlow​()` |
    `void` | `finishedInline​()` |
    `void` | `finishedMarker​()` |
    `void` | `finishedPassThrough​()` |
    `void` | `finishedRootInline​()` |
    `void` | `finishedTable​()` |
    `void` | `finishedTableCaption​()` |
    `void` | `finishedTableCell​()` |
    `void` | `finishedTableColumn​()` |
    `void` | `finishedTableColumnGroup​()` |
    `void` | `finishedTableRow​()` |
    `void` | `finishedTableSection​()` |
    `Renderer` | `getRenderer​()` |
    `void` | `handlePageBreak​(PageContext pageContext)` | This event handler is triggered by 'LayoutProcess.pageBreakEncountered()'.
    `void` | `startedBlock​(LayoutContext element)` |
    `void` | `startedDocument​(PageContext pageContext)` | Receives the information, that the document processing has been started.
    `void` | `startedFlow​(LayoutContext element)` |
    `void` | `startedInline​(LayoutContext element)` |
    `void` | `startedMarker​(LayoutContext element)` |
    `void` | `startedPassThrough​(LayoutContext element)` |
    `void` | `startedRootInline​(LayoutContext element)` |
    `void` | `startedTable​(LayoutContext element)` |
    `void` | `startedTableCaption​(LayoutContext context)` |
    `void` | `startedTableCell​(LayoutContext element)` |
    `void` | `startedTableColumn​(LayoutContext element)` |
    `void` | `startedTableColumnGroup​(LayoutContext element)` |
    `void` | `startedTableRow​(LayoutContext element)` |
    `void` | `startedTableSection​(LayoutContext element)` |

    - ### Methods inherited from interface org.jfree.layouting.StatefullComponent

      `saveState`

- - ### Method Detail

    - #### startedDocument

          void startedDocument​(PageContext pageContext)
                        throws NormalizationException

      Receives the information, that the document processing has been started. This is fired only once.
      Parameters:
        `pageContext` - the page context for the default page.
      Throws:
        `NormalizationException`

    - #### startedPassThrough

          void startedPassThrough​(LayoutContext element)
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### addPassThroughContent

          void addPassThroughContent​(LayoutContext node,
                                     ContentToken token)
                              throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedPassThrough

          void finishedPassThrough​()
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedFlow

          void startedFlow​(LayoutContext element)
                    throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedBlock

          void startedBlock​(LayoutContext element)
                     throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedRootInline

          void startedRootInline​(LayoutContext element)
                          throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTable

          void startedTable​(LayoutContext element)
                     throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableColumnGroup

          void startedTableColumnGroup​(LayoutContext element)
                                throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableColumn

          void startedTableColumn​(LayoutContext element)
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableSection

          void startedTableSection​(LayoutContext element)
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableRow

          void startedTableRow​(LayoutContext element)
                        throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableCell

          void startedTableCell​(LayoutContext element)
                         throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedMarker

          void startedMarker​(LayoutContext element)
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedInline

          void startedInline​(LayoutContext element)
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### addContent

          void addContent​(LayoutContext node,
                          ContentToken contentToken)
                   throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedInline

          void finishedInline​()
                       throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedMarker

          void finishedMarker​()
                       throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableCell

          void finishedTableCell​()
                          throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableRow

          void finishedTableRow​()
                         throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableSection

          void finishedTableSection​()
                             throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableColumn

          void finishedTableColumn​()
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableColumnGroup

          void finishedTableColumnGroup​()
                                 throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTable

          void finishedTable​()
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedRootInline

          void finishedRootInline​()
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedBlock

          void finishedBlock​()
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedFlow

          void finishedFlow​()
                     throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedDocument

          void finishedDocument​()
                         throws NormalizationException

      Receives notification, that a new flow has started. A new flow is started for each flowing or absolutly positioned element.
      Parameters:
        `box` -
      Throws:
        `NormalizationException`

    - #### handlePageBreak

          void handlePageBreak​(PageContext pageContext)

      This event handler is triggered by 'LayoutProcess.pageBreakEncountered()'.
      Parameters:
        `pageContext` -

    - #### getRenderer

          Renderer getRenderer​()

    - #### startedTableCaption

          void startedTableCaption​(LayoutContext context)
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableCaption

          void finishedTableCaption​()
                             throws NormalizationException

      Throws:
        `NormalizationException`